﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropertyGridSample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            SkinStorage.SetVisualStyle(this, "Metro");
            this.pgrid.SelectedObject = new Customer();
        }

        private void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            CustomEditor updownEditor = new CustomEditor() { HasPropertyType = true, PropertyType = typeof(int) };
            updownEditor.Editor = new PropertyGridSample1.ICustomTypeEditors.UpDownEditor();
            pgrid.CustomEditorCollection.Add(updownEditor);
            pgrid.RefreshPropertygrid();
        }
    }
    public class Customer
    {
        private string _name;
        private int _age;
        private string _SSN;
        private string _address;
        private string _email;

        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
            }
        }

        public string SSN
        {
            get
            {
                return _SSN;
            }
            set
            {
                _SSN = value;
            }
        }

        public string Address
        {
            get
            {
                return _address;
            }
            set
            {
                _address = value;
            }
        }
       
        public int Age
        {
            get
            {
                return _age;
            }
            set
            {
                _age = value;
            }
        }

        public string Email
        {
            get
            {
                return _email;
            }
            set
            {
                _email = value;
            }
        }
    }
    public class ICustomTypeEditors
    {
        public class UpDownEditor : ITypeEditor
        {
            public void Attach(PropertyViewItem property, PropertyItem info)
            {
            }

            UpDown upDown;
            public object Create(PropertyInfo propertyInfo)
            {
                upDown = new UpDown()
                {
                   MinValue = 2,
                   MaxValue=8,
                   NumberDecimalDigits=0
                };
                return upDown;
            }

            public void Detach(PropertyViewItem property)
            {
                throw new NotImplementedException();
            }
        }
    }
}
